package cn.iocoder.yudao.module.member.service.activity;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.controller.admin.activity.vo.ActivityPageReqVO;
import cn.iocoder.yudao.module.member.controller.admin.activity.vo.ActivityRespVO;
import cn.iocoder.yudao.module.member.controller.admin.activity.vo.ActivitySaveReqVO;
import cn.iocoder.yudao.module.member.controller.app.activity.vo.AppActivityPrizeDrawVO;
import cn.iocoder.yudao.module.member.controller.app.activity.vo.AppActivityRespVO;
import cn.iocoder.yudao.module.member.dal.dataobject.activity.ActivityDO;
import cn.iocoder.yudao.module.member.dal.dataobject.activityawardsuser.ActivityAwardsUserDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 活动 Service 接口
 *
 * @author 我是秦俊旗
 */
public interface ActivityService {

    /**
     * 创建活动
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createActivity(@Valid ActivitySaveReqVO createReqVO);

    /**
     * 更新活动
     *
     * @param updateReqVO 更新信息
     */
    void updateActivity(@Valid ActivitySaveReqVO updateReqVO);

    /**
     * 删除活动
     *
     * @param id 编号
     */
    void deleteActivity(Long id);

    /**
     * 获得活动
     *
     * @param id 编号
     * @return 活动
     */
    ActivityDO getActivity(Long id);

    /**
     * 获得活动分页
     *
     * @param pageReqVO 分页查询
     * @return 活动分页
     */
    PageResult<ActivityRespVO> getActivityPage(ActivityPageReqVO pageReqVO);



    /**
     * 获得用户活动分页
     *
    */
    PageResult<ActivityRespVO> getUserActivityPage(ActivityPageReqVO pageReqVO);


    List<ActivityAwardsUserDO> prizeDraw(@Valid AppActivityPrizeDrawVO drawVO);

    AppActivityRespVO getUserActivity(Long id,Long userId);

    AppActivityRespVO getUserActivityApplyInfo(Long id,Long userId);

    List<AppActivityRespVO> getReservatList();

    PageResult<ActivityRespVO> getActivityReservePage(ActivityPageReqVO pageReqVO);

}